<?php

namespace App;

use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;

class User extends Authenticatable
{
    use Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name', 'email', 'password',
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password', 'remember_token',
    ];

    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];

    // Others
    public function getTableColumns() { // テーブルのカラムを取得

        $table = $this->getTable();
        $columns = $this->getConnection()
            ->getSchemaBuilder()
            ->getColumnListing($table);
        $hidden_columns = $this->getHidden();
        return array_diff($columns, $hidden_columns); // hiddenとされているものを除外

    }

}
